import { Meta } from '@storybook/blocks'

<Meta title="Getting Started" />

# Getting started

The [Common Ground (CG) Design System](https://gitlab.com/commonground/core/design-system) is a reusable 
component library that helps CG projects build UIs faster. The goal is to make building durable UIs more 
productive and satisfying.

The components are written in React. The code examples are mostly JSX.

## Installation

Add the Design System to your project.

`npm install --save @commonground/design-system`

Install the peer dependencies if you don't have these installed already.

`npm install --save formik react react-dom styled-components @fontsource/source-sans-pro react-hook-form`

### Global styling

The `GlobalStyles` component needs to be included once. It contains the foundation (e.g. normalize.css, typography...) which other components rely on.
If you don't have the font 'Source Sans Pro' installed, you can import it here too. 

```
import { ThemeProvider } from 'styled-components'
import { GlobalStyles, defaultTheme } from '@commonground/design-system'
import '@fontsource/source-sans-pro/latin.css'
```

and in your App

```
  const App = () => {
    <div>
      <ThemeProvider theme={defaultTheme}>
        <GlobalStyles />
        <p>Welcome to my App!</p>
      </ThemeProvider>
    <div>
  }
```

Import components you want to use

`import { Button } from ‘@commonground/design-system’;`

and use them like so

```
  const example = () => (
    <div>
      <Button variant="primary">Do something</Button>
    </div>
  )
```

## Customizing the theme

The Design System is built using design tokens. If you want to customize the theme, 
you can do so by overriding these tokens.

Let's say you want your application to have a green background. 
We would have to update the token `backgroundColor` to achieve this.

For example. let's set it to green (`#00FF00`).
 
### **theme.js**

```
import { defaultTheme } from '@commonground/design-system'

const tokens = {
  ...defaultTheme.tokens,
}

const theme = {
  ...defaultTheme,

  tokens,

  // Generics
  colorBackground: '#00FF00',
}

export default theme
```

### **app.js**
```
import myCustomTheme from './theme.js'

const App = () => {
    <div>
      <ThemeProvider theme={myCustomTheme}>
        <GlobalStyles />
        <p>Welcome to my customised App!</p>
      </ThemeProvider>
    <div>
  }
```

We provide a [light](https://gitlab.com/commonground/core/design-system/-/blob/main/src/themes/default.js) 
and [dark](https://gitlab.com/commonground/core/design-system/-/blob/main/src/themes/dark.js) theme. 
Both can be customized using the design tokens.

## Tree-shaking

If performance is important for your application, use 'deep' imports.

Instead of:

```js
// ❌ Imports all of the components!
import { Button } from '@commonground/design-system'
```

Use:

```js
// ✅
import Button from '@commonground/design-system/dist/components/Button'
```

We have not enabled proper tree-shaking (yet).

### Content Security Policy (CSP) settings

Some components load images via the data scheme (eg. base64 encoded images). Because of this,
you might need to adjust the [CSP](https://developer.mozilla.org/en-US/docs/Web/HTTP/CSP) 
settings of your application.

To enable loading images via the data scheme for the `image-src` directive, 
use `img-src 'self' data:;`.


## Used by

- [NLX](https://nlx.io/)
- [developer.overheid.nl](https://developer.overheid.nl/)
- [Componentencatalogus](https://componentencatalogus.commonground.nl/)
